> For the complete documentation index, see [llms.txt](https://docs.xaman.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xaman.dev/environments/xapps-dapps/develop-and-test.md).

# Develop & Test

When building xApps, there are some tools to make building & sharing your xApp easier.

While developing your xApp, you may want to easily test & debug your web application. You may even benefit from live reload during development. You can expose your local development environment with a tool like [https://ngrok.io](https://ngrok.io/) or [https://localtunnel.me](https://localtunnel.me/) and configure your public URL as your xApp URL.

You can get access to the remote browser console using the techniques explained in the [Development & Debugging](/environments/xapps-dapps/debugging.md) article.

If you want to share your xApp with a small group of testers or team members, you can ask them for their Xaman Device Identifier (Xaman -> Settings -> Advanced). You can add up to 10 Device Identifiers as xApp testers, so they can open your sandboxed xApp.

{% hint style="info" %}
Warning! If you have multiple xApps (e.g. a live version & a test version, pointing to your development URL) please make sure to use the right API Key, otherwise your app can't communicate with the Xaman backend. Also note things like [https://github.com/XRPL-Labs/Developer-Help-Center/blob/main/js-ts-sdk/sdk-syntax/xumm.userstore](https://github.com/XRPL-Labs/Developer-Help-Center/blob/main/js-ts-sdk/sdk-syntax/xumm.userstore "mention") are API Key & user bound.
{% endhint %}

When you want to develop in your local browser instead of in Xaman, please see the "**OTT Replay**" section in the [Development & Debugging](/environments/xapps-dapps/debugging.md) article.

{% hint style="success" %}
We are currently working on a Desktop **xApp Development Application** so you can develop & test locally :tada: (Work in progress, more good things are coming)
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.xaman.dev/environments/xapps-dapps/develop-and-test.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
